Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 694020 (CVE-2019-5481, CVE-2019-5482) - <net-misc/curl-7.66.0: multiple vulnerabilities
Summary: <net-misc/curl-7.66.0: multiple vulnerabilities
Status: IN_PROGRESS
Alias: CVE-2019-5481, CVE-2019-5482
Product: Gentoo Security
Classification: Unclassified
Component: Vulnerabilities (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Security
URL:
Whiteboard: A3 [stable]
Keywords: STABLEREQ
Depends on:
Blocks:
 
Reported: 2019-09-11 07:00 UTC by Jeroen Roovers
Modified: 2019-11-12 18:08 UTC (History)
2 users (show)

See Also:
Package list:
net-misc/curl-7.66.0
Runtime testing required: ---
stable-bot: sanity-check+


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Comment 1 Jeroen Roovers gentoo-dev 2019-09-11 07:01:04 UTC
https://curl.haxx.se/docs/CVE-2019-5481.html

TFTP small blocksize heap buffer overflow
=========================================

Project curl Security Advisory, September 11th 2019 -
[Permalink](https://curl.haxx.se/docs/CVE-2019-5482.html)

VULNERABILITY
-------------

libcurl contains a heap buffer overflow in the function
(`tftp_receive_packet()`) that receives data from a TFTP server. It can call
`recvfrom()` with the default size for the buffer rather than with the size
that was used to allocate it. Thus, the content that might overwrite the heap
memory is controlled by the server.

This flaw is only triggered if the TFTP server sends an OACK without the BLKSIZE
option, when a BLKSIZE smaller than 512 bytes was requested by the TFTP client.
OACK is a TFTP extension and is not used by all TFTP servers.

Users choosing a smaller block size than default should be rare as the primary
use case for changing the size is to make it larger.

It is rare for users to use TFTP across the Internet. It is most commonly used
within local networks. TFTP as a protocol is always inherently insecure.

This issue was introduced by the add of the TFTP BLKSIZE option handling. It
was previously incompletely fixed by an almost identical issue called
CVE-2019-5436.

We are not aware of any exploit of this flaw.
Comment 2 Jeroen Roovers gentoo-dev 2019-09-11 07:01:32 UTC
(In reply to Jeroen Roovers from comment #1)

oop, sorry
Comment 3 Anthony Basile gentoo-dev 2019-10-27 00:00:59 UTC
(In reply to Jeroen Roovers from comment #2)
> (In reply to Jeroen Roovers from comment #1)
> 
> oop, sorry

Thanks Jer.  Its ready for stabilization.
Comment 4 Stabilization helper bot gentoo-dev 2019-10-27 22:02:40 UTC
An automated check of this bug failed - repoman reported dependency errors (55 lines truncated): 

> dependency.bad net-misc/curl/curl-7.66.0.ebuild: DEPEND: amd64(default/linux/amd64/17.0) ['net-libs/quiche[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_riscv_lp64d(-)?,abi_riscv_lp64(-)?,abi_s390_32(-)?,abi_s390_64(-)?]']
> dependency.bad net-misc/curl/curl-7.66.0.ebuild: RDEPEND: amd64(default/linux/amd64/17.0) ['net-libs/quiche[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_riscv_lp64d(-)?,abi_riscv_lp64(-)?,abi_s390_32(-)?,abi_s390_64(-)?]']
> dependency.bad net-misc/curl/curl-7.66.0.ebuild: DEPEND: amd64(default/linux/amd64/17.0/desktop) ['net-libs/quiche[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_riscv_lp64d(-)?,abi_riscv_lp64(-)?,abi_s390_32(-)?,abi_s390_64(-)?]']
Comment 5 Thomas Deutschmann gentoo-dev Security 2019-10-27 23:21:26 UTC
x86 stable
Comment 6 Stabilization helper bot gentoo-dev 2019-10-28 00:05:45 UTC
An automated check of this bug failed - repoman reported dependency errors (55 lines truncated): 

> dependency.bad net-misc/curl/curl-7.66.0.ebuild: DEPEND: amd64(default/linux/amd64/17.0) ['net-libs/quiche[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_riscv_lp64d(-)?,abi_riscv_lp64(-)?,abi_s390_32(-)?,abi_s390_64(-)?]']
> dependency.bad net-misc/curl/curl-7.66.0.ebuild: RDEPEND: amd64(default/linux/amd64/17.0) ['net-libs/quiche[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_riscv_lp64d(-)?,abi_riscv_lp64(-)?,abi_s390_32(-)?,abi_s390_64(-)?]']
> dependency.bad net-misc/curl/curl-7.66.0.ebuild: DEPEND: amd64(default/linux/amd64/17.0/desktop) ['net-libs/quiche[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_riscv_lp64d(-)?,abi_riscv_lp64(-)?,abi_s390_32(-)?,abi_s390_64(-)?]']
Comment 7 Larry the Git Cow gentoo-dev 2019-10-28 13:08:28 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5ac189e16b0627ab6ca16302e8392610a69e0fce

commit 5ac189e16b0627ab6ca16302e8392610a69e0fce
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2019-10-28 13:07:20 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2019-10-28 13:07:20 +0000

    profiles: amd64: Mask net-misc/curl[quiche]
    
    Bug: https://bugs.gentoo.org/694020
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 profiles/arch/amd64/package.use.stable.mask | 5 +++++
 1 file changed, 5 insertions(+)
Comment 8 Agostino Sarubbo gentoo-dev 2019-10-29 09:29:58 UTC
amd64 stable
Comment 9 Mikle Kolyada archtester Gentoo Infrastructure gentoo-dev Security 2019-11-01 10:11:36 UTC
arm stable
Comment 10 Rolf Eike Beer 2019-11-02 13:37:27 UTC
hppa stable
Comment 11 Rolf Eike Beer 2019-11-02 15:17:13 UTC
sparc stable
Comment 12 Aaron Bauman Gentoo Infrastructure gentoo-dev Security 2019-11-06 21:57:34 UTC
arm64 stable
Comment 13 Mikle Kolyada archtester Gentoo Infrastructure gentoo-dev Security 2019-11-08 08:33:32 UTC
s390 stable
Comment 14 Matt Turner gentoo-dev 2019-11-09 22:57:05 UTC
alpha stable
Comment 15 Agostino Sarubbo gentoo-dev 2019-11-12 10:39:48 UTC
ppc64 stable
Comment 16 Agostino Sarubbo gentoo-dev 2019-11-12 18:08:54 UTC
ppc stable